@ECHO OFF
REM
REM Taken (and adapted) from: http://svn.haxx.se/users/archive-2006-02/att-0473/genSvnVer.bat.txt
REM

SET WCPATH=%1
SET OUTPUTFILE=%2
ECHO Updating the SVN revision for "%WCPATH:"=%" into %OUTPUTFILE%...

REM  I hate Windows bat. files.  CN
REM  Found this method of executing the `svnversion` program and storing
REM  the returned value in a environment variable.
REM    http://svn.haxx.se/users/archive-2004-09/0502.shtml
REM
REM  Version 1.3.0 of `svnversion` doesn't require a path, but it is left
REM  for compatability with previous versions of the program

FOR /F "usebackq" %%s IN (`svnversion %WCPATH:"=%`) DO @SET REV=%%s
REM  Now that we have the revision string, lets build a class.

REM  Be sure to tell anyone who looks at this file it was generated by
REM  a program and not hand writen.  Do not commit the output of this
REM  batch script to your repository!  Just the script.

ECHO /* > Revision.cs.tmp
ECHO  * THIS CLASS WAS GENERATED BY A PROGRAM >> Revision.cs.tmp
ECHO  * Rerun `%0` to update the revision number >> Revision.cs.tmp
ECHO  *  >> Revision.cs.tmp
ECHO  * There could even be bugs in this class.  :) >> Revision.cs.tmp
ECHO  * Report to chris@nesser.org >> Revision.cs.tmp
ECHO  */ >> Revision.cs.tmp
ECHO. >> Revision.cs.tmp
ECHO namespace Bitground.Common.Helpers >> Revision.cs.tmp
ECHO { >> Revision.cs.tmp
ECHO 	internal class Revision >> Revision.cs.tmp
ECHO 	{ >> Revision.cs.tmp
ECHO 		private static string ver = "%REV%"; >> Revision.cs.tmp
ECHO. >> Revision.cs.tmp
ECHO 		static Revision() >> Revision.cs.tmp
ECHO 		{} >> Revision.cs.tmp
ECHO. >> Revision.cs.tmp
ECHO 		public static string getFullVersion() >> Revision.cs.tmp
ECHO 		{ >> Revision.cs.tmp
ECHO 			return ver; >> Revision.cs.tmp
ECHO 		} >> Revision.cs.tmp
ECHO. >> Revision.cs.tmp
ECHO 		public static string getMinVersion()  >> Revision.cs.tmp
ECHO 		{  >> Revision.cs.tmp
ECHO 		int i = ver.IndexOf(":");  >> Revision.cs.tmp
ECHO 		if ( i ^> 0 )  >> Revision.cs.tmp
ECHO 		{ >> Revision.cs.tmp
ECHO 			// Check for modifications >> Revision.cs.tmp
ECHO 			if ( ver.EndsWith("M") ) >> Revision.cs.tmp
ECHO 				return ver.Substring(0,i) + "M"; >> Revision.cs.tmp
ECHO 			else >> Revision.cs.tmp
ECHO 				return ver.Substring(0,i); >> Revision.cs.tmp
ECHO 		} >> Revision.cs.tmp
ECHO 		else  >> Revision.cs.tmp
ECHO 			return ver;  >> Revision.cs.tmp
ECHO 		} >> Revision.cs.tmp
ECHO.  >> Revision.cs.tmp
ECHO 		public static string getMaxVersion()   >> Revision.cs.tmp
ECHO 		{   >> Revision.cs.tmp
ECHO 			int i = ver.IndexOf(":");  >> Revision.cs.tmp
ECHO 			if ( i ^> 0 )   >> Revision.cs.tmp
ECHO 				return ver.Substring(i+1); >> Revision.cs.tmp
ECHO 			else   >> Revision.cs.tmp
ECHO 				return ver;   >> Revision.cs.tmp
ECHO 		}   >> Revision.cs.tmp
ECHO 	} >> Revision.cs.tmp
ECHO } >> Revision.cs.tmp

MOVE Revision.cs.tmp %OUTPUTFILE%
ECHO The SVN revision was updated to %REV%
