// Bitground Software common helpers library
// http://www.bitground.com/
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Bitground.Common.Helpers
{
    public class Pair
    {
        public object First;
        public object Second;

        public Pair()
        {
        }

        public Pair(object obFirst, object obSecond)
        {
            First = obFirst;
            Second = obSecond;
        }

        public override bool Equals(object obj)
        {
            if (null == obj)
            {
                return false;
            }

            if (!(obj is Pair))
            {
                return false;
            }

            Pair p = obj as Pair;

            return p.First.Equals(First) && p.Second.Equals(Second);
        }

        public override int GetHashCode()
        {
            return First.GetHashCode() ^ Second.GetHashCode();
        }

        public class Comparer : IComparer
        {
            int IComparer.Compare(object x, object y)
            {
                int ret = System.Collections.Comparer.DefaultInvariant.Compare((x as Pair).First, (y as Pair).First);
                if (ret != 0)
                {
                    return ret;
                }
                return System.Collections.Comparer.DefaultInvariant.Compare((x as Pair).Second, (y as Pair).Second);
            }
        }
    }
}
