// Bitground Software common helpers library
// http://www.bitground.com/
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Bitground.Common.Helpers
{
    public class ThreePly
    {
        public object First;
        public object Second;
        public object Third;

        public ThreePly()
        {
        }

        public ThreePly(object obFirst, object obSecond, object obThird)
        {
            First = obFirst;
            Second = obSecond;
            Third = obThird;
        }

        public override bool Equals(object obj)
        {
            if (null == obj)
            {
                return false;
            }

            if (!(obj is ThreePly))
            {
                return false;
            }

            ThreePly t = obj as ThreePly;

            return t.First.Equals(First) && t.Second.Equals(Second) && t.Third.Equals(Third);
        }

        public override int GetHashCode()
        {
            return First.GetHashCode() ^ Second.GetHashCode() ^ Third.GetHashCode();
        }

        public class Comparer : IComparer
        {
            int IComparer.Compare(object x, object y)
            {
                int ret = System.Collections.Comparer.DefaultInvariant.Compare((x as ThreePly).First, (y as ThreePly).First);
                if (ret != 0)
                {
                    return ret;
                }
                ret = System.Collections.Comparer.DefaultInvariant.Compare((x as ThreePly).Second, (y as ThreePly).Second);
                if (ret != 0)
                {
                    return ret;
                }
                return System.Collections.Comparer.DefaultInvariant.Compare((x as ThreePly).Third, (y as ThreePly).Third);
            }
        }
    }
}
