// Bitground Software common helpers library
// http://www.bitground.com/
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

namespace Bitground.Common.Helpers
{
    public class Html
    {
        public static string Encode(char c)
        {
            return HttpUtility.HtmlEncode(c.ToString());
        }

        public static string Encode(string strText)
        {
            return HttpUtility.HtmlEncode(strText);
        }

        public static string EncodeText(object obText)
        {
            return EncodeText(obText as string);
        }

        public static string Encode(string strText, int intMaxEncodedLength)
        {
            if (null == strText)
            {
                return strText;
            }

            string strEncodedText = Encode(strText);

            if (intMaxEncodedLength < strEncodedText.Length)
            {
                StringBuilder sb = new StringBuilder();
                int intBuilderLength = sb.Length;
                int intLastBuilderLenght = intBuilderLength;

                int intPos = 0;
                int intTextLength = strText.Length;

                while ((intBuilderLength <= intMaxEncodedLength) && (intPos < intTextLength))
                {
                    sb.Append(Encode(strText[intPos]));
                    intPos++;
                    intLastBuilderLenght = intBuilderLength;
                    intBuilderLength = sb.Length;
                }

                return sb.ToString().Substring(0, intLastBuilderLenght);
            }

            return strEncodedText;
        }

        public static string CutEncodedText(string strEncodedText, int intMaxEncodedLength)
        {
            if (strEncodedText.Length <= intMaxEncodedLength)
            {
                return strEncodedText;
            }

            return Encode(Decode(strEncodedText), intMaxEncodedLength);
        }

        public static string Decode(string strText)
        {
            return HttpUtility.HtmlDecode(strText);
        }

        public static string EncodeText(string strText)
        {
            return (Nulls.String == strText) ?
                        "" :
                        Encode(strText.Trim());
        }

        public static string EncodeText(string strText, int intMaxEncodedLength)
        {
            return (Nulls.String == strText) ?
                        "" :
                        Encode(strText.Trim(), intMaxEncodedLength);
        }

        public static string DecodeText(string strText)
        {
            return (Nulls.String == strText) ?
                        "" :
                        Decode(strText);
        }
    }
}
