﻿// Bitground Software common helpers library
// http://www.bitground.com/
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Bitground.Common.Helpers
{
    public abstract class RandomDelay
    {
        // suspend the execution of the current thread between minMilliseconds and maxMilliseconds
        public static void Wait(double minSeconds, double maxSeconds)
        {
            int delay = PseudoRandom.GetInt32((int)(1000.0 * minSeconds), (int)(1000.0 * maxSeconds));
            if (Log.CanLogTrace) Log.Trace("[DELAY] Wait: {0}ms", delay);
            System.Threading.Thread.Sleep(delay);
        }

        // suspend the execution of the current thread between minMilliseconds and maxMilliseconds
        public static void Wait(int minMilliseconds, int maxMilliseconds)
        {
            int delay = PseudoRandom.GetInt32(minMilliseconds, maxMilliseconds);
            if (Log.CanLogTrace) Log.Trace("[DELAY] Wait: {0}ms", delay);
            System.Threading.Thread.Sleep(delay);
        }

        // suspend the execution of the current thread between 0.05 and 0.2 seconds
        public static void WaitVeryShort()
        {
            int delay = PseudoRandom.GetInt32(50, 200);
            if (Log.CanLogTrace) Log.Trace("[DELAY] WaitVeryShort: {0}ms", delay);
            System.Threading.Thread.Sleep(delay);
        }

        // suspend the execution of the current thread between 0.25 and 1 seconds
        public static void WaitShort()
        {
            int delay = PseudoRandom.GetInt32(250, 1000);
            if (Log.CanLogTrace) Log.Trace("[DELAY] WaitShort: {0}ms", delay);
            System.Threading.Thread.Sleep(delay);
        }

        // suspend the execution of the current thread between 1 and 3 seconds
        public static void WaitMedium()
        {
            int delay = PseudoRandom.GetInt32(1000, 3000);
            if (Log.CanLogTrace) Log.Trace("[DELAY] WaitMedium: {0}ms", delay);
            System.Threading.Thread.Sleep(delay);
        }
    }
}
