using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Rest.Xml
{
    /// <summary>
    /// This class will encapsulate schema knowledge of the specific service
    /// in use. Designed to be supplied to a RestServiceBase to be used for
    /// XML validation.
    /// </summary>
    public interface IRestServiceXmlSchema
    {
        /// <summary>
        /// Identifies an error Response
        /// </summary>
        /// <param Name="xmlDocument"></param>
        /// <returns></returns>
        Boolean IsErrorResponse(XmlDocument xmlDocument);

        /// <summary>
        /// Gets an error message
        /// </summary>
        /// <param name="xmlDocument"></param>
        /// <returns></returns>
        String GetExceptionMessage(XmlDocument xmlDocument);
    }
}
