﻿// zkBox C# client
// http://www.zkbox.com/developers/client/csharp
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bitground.Common.Helpers;

namespace Bitground.zkBox.Client.CS
{
    public class Applications : ApiHandler
    {
        public Applications(Handler handler)
            : base(handler)
        {
        }

        #region Get application info

        public class GetApplicationInfo : WSRet<GetApplicationInfo.Data>
        {
            public class Data
            {
                public long usersCount;
                public long objectsCount;
            }
        };

        public GetApplicationInfo GetInfo()
        {
            GetApplicationInfo ret = api.Call<GetApplicationInfo, GetApplicationInfo.Data>(
                "Applications.GetInfo",
                new object[] 
                {   
                },
                () =>
                {
                    if (Log.CanLogTrace) Log.Trace("Getting the application info");

                    return api.Authenticate_Application<GetApplicationInfo, GetApplicationInfo.Data>(
                        "GET",
                        "application/info",
                        new object[] 
                        { 
                        },
                        (data) =>
                        {
                            long objectsCount = (int)data["objectsCount"];
                            long usersCount = (int)data["usersCount"];

                            if (Log.CanLogTrace) Log.Trace("The application info was retrieved");
                            return new GetApplicationInfo
                            {
                                error = 0,
                                data = new GetApplicationInfo.Data
                                {
                                    objectsCount = objectsCount,
                                    usersCount = usersCount
                                }
                            };
                        });
                });

            return ret;
        }

        #endregion
    }
}
