﻿// zkBox C# client
// http://www.zkbox.com/developers/client/csharp
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bitground.Common.Helpers;

namespace Bitground.zkBox.Client.CS
{
    // TODO_LATER: implement the cache using a real solution instead of a simple hashtable
    internal class Cache
    {
        private Hashtable h;

        public Cache()
        {
            h = new Hashtable();
            if (Log.CanLogInfo) Log.Info("The cache was initialized. The objects will be cached when necessary");
        }

        public void SetItem(string key, object value)
        {
            h[key] = value;
            if (Log.CanLogTrace) Log.Trace("Cache.SetItem('{0}')='{1}'", key, Params.GetObjectAsString(value));
        }

        public object GetItem(string key)
        {
            object ret = h[key];
            if (Log.CanLogTrace) Log.Trace("Cache.GetItem('{0}') will return '{1}'", key, Params.GetObjectAsString(ret));
            return ret;
        }

        public void RemoveItem(string key)
        {
            if (Log.CanLogTrace) Log.Trace("Cache.RemoveItem('{0}')", key);
            h.Remove(key);
        }

        public void ClearAllItems()
        {
            if (Log.CanLogTrace) Log.Trace("Cache.ClearAllItems()");
            h.Clear();
        }

        public bool ContainsItem(string key)
        {
            bool ret = h.ContainsKey(key);

            if (Log.CanLogTrace) Log.Trace("Cache.ContainsItem('{0}') will return '{1}'", key, ret);
            return ret;
        }
    }
}
