﻿// zkBox C# client
// http://www.zkbox.com/developers/client/csharp
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using Rest;
using Rest.Service;
using Rest.Transport;

namespace Bitground.zkBox.Client.CS
{
    internal class Proxy : ProxyBase
    {
        /// <summary>
        /// ctor : String, String
        /// </summary>
        public Proxy(Handler.Init init)
            : base(init)
        { }

        /// <summary>
        /// Returns true if the supplied document represents an exception
        /// </summary>
        /// <param name="xmlDocument"></param>
        /// <returns></returns>
        protected sealed override Boolean IsErrorResponse(XmlDocument xmlDocument)
        {
            return xmlDocument.SelectSingleNode("//Error") != null; 
        }

        /// <summary>
        /// Gets an error message
        /// </summary>
        /// <param name="xmlDocument"></param>
        /// <returns></returns>
        protected sealed override String GetExceptionMessage(XmlDocument xmlDocument)
        {
            return
                "Error code: " +
                xmlDocument.SelectSingleNode("//Error/Code/text()").Value + "." +
                xmlDocument.SelectSingleNode("//Error/Message/text()").Value;
        }
    }
}
