﻿// zkBox C# client
// http://www.zkbox.com/developers/client/csharp
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bitground.Common.Helpers;

namespace Bitground.zkBox.Client.CS
{
    internal class Status
    {
        public string user = "";
        public string pass = "";

        public string userId = "";
        public string userVersion = "";
        public string sessionId = "";

        public string sessionKey = "";

        public string cryptoKey = "";

        public bool isAuthenticated = false;

        public void updateAuth()
        {
            isAuthenticated = true;

            if (Log.CanLogTrace) Log.Trace("The authentication status was set to: {0}", ToString());
        }

        public void clearAuth()
        {
            user = "";
            pass = "";

            userId = "";
            userVersion = "";
            sessionId = "";

            sessionKey = "";

            cryptoKey = "";

            isAuthenticated = false;

            if (Log.CanLogTrace) Log.Trace("The authentication status was cleared");
        }

        public override string ToString()
        {
            return String.Format(
                "[user='{0}' pass='{1}' userId='{2}' userVersion='{3}' sessionId='{4}' sessionKey=='{5}' cryptoKey='{6}'",
                user,
                pass,
                userId,
                userVersion,
                sessionId,
                sessionKey,
                cryptoKey);
        }
    }
}
