@ECHO OFF

SET ZKBOX_API_ALL_UNCOMPRESSED="%~dp0..\api.uncompressed.js"
SET ZKBOX_API_ALL_COMPRESSED="%~dp0..\api.js"
ECHO Building %ZKBOX_API_ALL_UNCOMPRESSED%...
CAT "%~dp0build_utf8marker.txt" > %ZKBOX_API_ALL_UNCOMPRESSED%
:: // api version 1.0
ECHO /*!*********************************** >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO  *   zkBox JavaScript client v1.0   * >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO  ************************************/ >> %ZKBOX_API_ALL_UNCOMPRESSED%
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::





:: add the header
CALL :add-js zkBox.core.header.js

:: encryption related libs ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: http://www.json.org/js.html
CALL :add-js json2.js

:: http://ats.oka.nu/titaniumcore/js/tools/binary.js
CALL :add-js binary.js

:: http://www.monsur.com/projects/jscache/
CALL :add-js cache.js

:: http://www.leemon.com/crypto/BigInt.js
CALL :add-js BigInt.js

:: http://ats.oka.nu/titaniumcore/js/crypto/jsSHA.js
:: original by Brian Turek: http://jssha.sourceforge.net/
CALL :add-js jsSHA.js

:: http://ats.oka.nu/titaniumcore/js/crypto/SHA.js
CALL :add-js SHA.js

:: http://pajhome.org.uk/crypt/md5/sha512.html
:: specs: http://csrc.nist.gov/publications/fips/fips180-2/fips180-2.pdf
CALL :add-js sha512.js

:: http://github.com/markpercival/gibberish-aes/tree/master
:: the standard is defined here: http://www.csrc.nist.gov/publications/fips/fips197/fips-197.pdf
CALL :add-js gibberish-aes.js



:: zkBox core ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
CALL :add-js zkBox.core.js



:: jQuery libs ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: original from http://plugins.jquery.com/project/Dump
CALL :add-js zkBox.jquery.dump.js

:: original from http://projects.allmarkedup.com/jquery_url_parser/
CALL :add-js zkBox.jquery.url.js

:: original from http://plugins.jquery.com/project/ajaxq
CALL :add-js zkBox.jquery.ajaxq.js

:: original from http://trainofthoughts.org/repo/getfile?f=jquery/jquery.debug.js&v=40
CALL :add-js zkBox.jquery.debug.js

:: original from http://plugins.jquery.com/project/cookie
CALL :add-js zkBox.jquery.cookie.js



:: zkBox libs ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
CALL :add-js zkBox.conf.js
CALL :add-js zkBox.status.js
CALL :add-js zkBox.utils.js
CALL :add-js zkBox.utils.cache.js
CALL :add-js zkBox.cache.js
CALL :add-js zkBox.cache.core.js
CALL :add-js zkBox.cache.transactions.js
CALL :add-js zkBox.cache.transactions.core.js
CALL :add-js zkBox.cache.batch.js
CALL :add-js zkBox.cache.batch.core.js
CALL :add-js zkBox.crypto.js
CALL :add-js zkBox.crypto.srp.js
CALL :add-js zkBox.data.client.js
CALL :add-js zkBox.data.server.js
CALL :add-js zkBox.model.js
CALL :add-js zkBox.model.errors.js
CALL :add-js zkBox.callbacks.js
CALL :add-js zkBox.maintenance.core.js
CALL :add-js zkBox.maintenance.js
CALL :add-js zkBox.applications.core.js
CALL :add-js zkBox.applications.js
CALL :add-js zkBox.users.core.js
CALL :add-js zkBox.users.js
CALL :add-js zkBox.objects.crypto.js
CALL :add-js zkBox.objects.core.js
CALL :add-js zkBox.objects.combined.js
CALL :add-js zkBox.objects.js
CALL :add-js zkBox.transactions.js
CALL :add-js zkBox.transactions.core.js
CALL :add-js zkBox.transactions.management.js
CALL :add-js zkBox.transactions.objects.js
CALL :add-js zkBox.batch.js
CALL :add-js zkBox.batch.core.js
CALL :add-js zkBox.batch.management.js
CALL :add-js zkBox.batch.objects.js


CALL :compress-js %ZKBOX_API_ALL_UNCOMPRESSED% %ZKBOX_API_ALL_COMPRESSED%





:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::: BUILD JS :::::::::::::::::::::::::::::::::::
GOTO :EOF

:add-js
ECHO. >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO /************************************************ >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO **** %1 ***** >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO ************************************************/ >> %ZKBOX_API_ALL_UNCOMPRESSED%
CALL :AppendToTextFile %ZKBOX_API_ALL_UNCOMPRESSED% "%~dp0%1"
ECHO ; >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO. >> %ZKBOX_API_ALL_UNCOMPRESSED%
ECHO. >> %ZKBOX_API_ALL_UNCOMPRESSED%
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::: COMMON ::::::::::::::::::::::::::::::::::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:AppendToTextFile
:: Appending a file (utf8 encoded or not) to another file. 
:: Output will always be UTF8 encoded.
:: %1 must be the name of the result file
:: %2 must be the name of the file to be appended to the result file
SET UTF8MARKER="%~dp0build_utf8marker.txt"
IF EXIST %1 GOTO AppendToTextFileAlreadyExist

CAT %UTF8MARKER% > %1

:AppendToTextFileAlreadyExist

type %2 | head --bytes=3 | diff -q --binary - %UTF8MARKER% 2>&1 > NUL
IF ERRORLEVEL 1 GOTO AppendToTextFileNoUtf8Header
ECHO Appending utf8 file %2 to %1
::skip the utf8 header
dd bs=1 if=%2 skip=3 >> %1

GOTO :EOF

:AppendToTextFileNoUtf8Header
ECHO Appending non-utf8 file %2 to %1
cat -B %2 >> %1

GOTO :EOF

:compress-js
::TODO_LATER: make this more flexible !!!
SET TOOL_JAVA="c:\Program Files\Java\jre6\bin\java.exe"
SET COMMONLOCATION=d:\Projects\Common
SET JS_SRC=%1
SET JS_DEST=%2
ECHO Compressing js %JS_SRC% to %JS_DEST%
SET JS_COMPRESSOR=%TOOL_JAVA% -jar %COMMONLOCATION%\Tools\Misc\yuicompressor-2.4.2.jar
SET JS_COMPRESSOR_OPTIONS=--charset utf8 --type js -v --line-break 5000
ECHO executing: %JS_COMPRESSOR% %JS_COMPRESSOR_OPTIONS% %JS_SRC% -o %JS_DEST%
%JS_COMPRESSOR% %JS_COMPRESSOR_OPTIONS% %JS_SRC% -o %JS_DEST%
GOTO :eof
