﻿// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


// returns true if the operation succeeded, null otherwise
$zkBox.cache.AddObject = function(ob)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> AddObject (ob="{0}")]',
            $zkBox.utils.dump(ob));

        if (!ob.objectId) throw "Cache.AddObject: ob.objectId was not provided";
        
        return $zkBox.cache.core.AddObject(ob);
    }

    return null;
}



// returns true if the operation succeeded, null otherwise
$zkBox.cache.UpdateObject = function(ob)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> UpdateObject (ob="{0}")]',
            $zkBox.utils.dump(ob));

        if (!ob.objectId) throw "Cache.UpdateObject: ob.objectId was not provided";
        
        return $zkBox.cache.core.UpdateObject(ob);
    }
    
    return null;
}



// returns the object if it's in the cache, null otherwise
$zkBox.cache.GetObjectCheck = function(objectId)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> GetObjectCheck (objectId="{0}")]',
            $zkBox.utils.dump(objectId));

        if (!objectId) throw "Cache.GetObjectCheck: objectId was not provided";
        
        return $zkBox.cache.core.GetObjectCheck(objectId);
    }

    return null;
}

// returns true if the operation succeeded, null otherwise
$zkBox.cache.GetObjectUpdate = function(ob)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> GetObjectUpdate (ob="{0}")]',
            $zkBox.utils.dump(ob));

        if (!ob.objectId) throw "Cache.GetObjectCheck: objectId was not provided";
        
        return $zkBox.cache.core.GetObjectUpdate(ob);
    }

    return null;
}



// returns true if the operation succeeded, null otherwise
$zkBox.cache.DeleteObject = function(ob)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> DeleteObject (ob="{0}")]',
            $zkBox.utils.dump(ob));

        if (!ob.objectId) throw "Cache.DeleteObject: ob.objectId was not provided";

        return $zkBox.cache.core.DeleteObject(ob);
    }

    return null;
}



// returns true if the operation succeeded, null otherwise
$zkBox.cache.GetObjectsListCheck = function(ctx)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> GetObjectsListCheck (ctx="{0}")]',
            $zkBox.utils.dump(ctx));

        ctx.checkExecuted = true;
        $zkBox.cache.core.GetObjectsListInit(ctx);

        return $zkBox.cache.core.GetObjectsListCheck(ctx);
    }

    return null;
}

// returns true if the operation succeeded, null otherwise
$zkBox.cache.GetObjectsListUpdate = function(ctx)
{
    if ($zkBox.conf.Cache === true)
    {
        if ($zkBox.logging) $zkBox.utils.log('[CACHE -> GetObjectsListUpdate (ctx="{0}")]',
            $zkBox.utils.dump(ctx));

        if (!ctx.checkExecuted)
        {
            $zkBox.cache.core.GetObjectsListInit(ctx);
        }
        
        return $zkBox.cache.core.GetObjectsListUpdate(ctx);
    }

    return null;
}


