// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


$zkBox.conf =
{
    ShowError: function(err)
    {
        // Errors:
        // 10 Unexpected ajax object returned
        // 11 Failure when calling method

        var s = "zkBox error: ";
        switch (err)
        {
            case 10:
                s += "Unexpected ajax object returned";
                break;

            case 11:
                s += "Failure when calling method";
                break;

            default:
                s += "Unhandled error";
                break;
        }

        s += " [" + err + "]";
        if ($zkBox.logging) $zkBox.utils.log(s);
    },

    //ProxyUrl: "https://api.dev.zkbox.com/rest",
    ProxyUrl: "",

    Log: false,
    
    Cache: true,

    SRP:
    {
        // this should be kept in sync with Bitground.Common.Helpers.Crypto.SRP.NHex/gHex/kHex
        N: "D4C7F8A2B32C11B8FBA9581EC4BA4F1B04215642EF7355E37C0FC0443EF756EA2C6B8EEB755A1C723027663CAA265EF785B8FF6A9B35227A52D86633DBDFCA43",
        g: "2",
        k: "738B8451178420B53F6603BD0B44B8BB50B80D1EFE3100E8E30C05EC7119502CA3974FA7FDFFADF0BABD20CBFA405A56BEAD38686811835997319EEDEE6B15C6"
    },
    
    AuthCookie:
    {
        Name: "X-zkBox-UserAuth",
        Expires: null,          // expire when browser exits
        Path: "/missing_path",  // the cookie's path
        
        Secure: true            // cookie sent on HTTPS only
    }
}
