// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


var $zkBox =
{
    logging: false,

    Init: function(options)
    {
        if (typeof options == 'object')
        {
            if (typeof options.ProxyUrl === 'string') { $zkBox.conf.ProxyUrl = options.ProxyUrl; }

            if ("" === $zkBox.conf.ProxyUrl)
            {
                throw "zkBox: ProxyUrl was not specified";
            }


            if (typeof options.ShowError === 'function') { $zkBox.conf.ShowError = options.ShowError; }
            if (typeof options.Log === 'boolean') $zkBox.conf.Log = options.Log;
            $zkBox.logging = $zkBox.conf.Log;

            if (typeof options.Cache === 'boolean') $zkBox.conf.Cache = options.Cache;

            // allow changing the SRP parameters?
            //if (typeof options.SRP == 'object')
            //{
            //    $zkBox.conf.SRP = new Object();
            //    $zkBox.conf.SRP.N = options.SRP.N;
            //    $zkBox.conf.SRP.g = options.SRP.g;
            //    $zkBox.conf.SRP.k = options.SRP.k;
            //};
            
            //if (typeof options.AuthCookie == 'object')
            //{
            //    if (typeof (options.AuthCookie.Expires) != "undefined") $zkBox.conf.AuthCookie.Expires = options.AuthCookie.Expires;
            //    if (typeof (options.AuthCookie.Path) != "undefined") $zkBox.conf.AuthCookie.Path = options.AuthCookie.Path;
            //    if (typeof (options.AuthCookie.Secure) != "undefined") $zkBox.conf.AuthCookie.Secure = options.AuthCookie.Secure;
            //}

            $zkBox.conf.AuthCookie.Path = $zkBox.jquery.url.setUrl($zkBox.conf.ProxyUrl).attr("path");
        }

        // using AES on 256 bits
        GibberishAES.size(256)

        $zkBox.utils.cache.initialize();

        $zkBox.jquery.debug($zkBox.conf.Log);
        $zkBox.crypto.srp.initialize(
            $zkBox.conf.SRP.N,
            $zkBox.conf.SRP.g,
            $zkBox.conf.SRP.k);
    }
}


$zkBox.jquery =
{
}


$zkBox.data =
{
}

$zkBox.callbacks =
{
}

$zkBox.cache =
{
}

$zkBox.cache.core =
{
}

$zkBox.cache.transactions =
{
}

$zkBox.cache.transactions.core =
{
}

$zkBox.cache.batch =
{
}

$zkBox.cache.batch.core =
{
}

$zkBox.maintenance =
{
}

$zkBox.maintenance.core =
{
}

$zkBox.applications =
{
}

$zkBox.applications.core =
{
}

$zkBox.users =
{
}

$zkBox.users.core =
{
}

$zkBox.objects =
{
}

$zkBox.objects.crypto =
{
}

$zkBox.objects.core =
{
}

$zkBox.objects.combined =
{
}

$zkBox.transactions =
{
}

$zkBox.transactions.core =
{
}

$zkBox.transactions.management =
{
}

$zkBox.transactions.objects =
{
}

$zkBox.batch =
{
}

$zkBox.batch.core =
{
}

$zkBox.batch.management =
{
}

$zkBox.batch.objects =
{
}