// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


//////////////////////////////////
////////  api operations  ////////
//////////////////////////////////

// returns true if the operation succeeded, false otherwise
$zkBox.StartMaintenance = function()
{
    var ret = false;

    $zkBox.utils.runFunctionOnly("fnStart", $zkBox.callbacks.fnStart)("StartMaintenance");

    $zkBox.maintenance.core.StartMaintenance(
        function(msg)
        {
            $zkBox.utils.runFunctionOnly("fnProgress", $zkBox.callbacks.fnProgress)(msg);
        },
        function()
        {
            $zkBox.utils.runFunctionOnly("fnSuccess", $zkBox.callbacks.fnSuccess)();
            ret = true;
        },
        function(error)
        {
            $zkBox.utils.runFunctionOnly("fnError", $zkBox.callbacks.fnError)(error);
        });

    $zkBox.utils.runFunctionOnly("fnStop", $zkBox.callbacks.fnStop)("StartMaintenance");

    return ret;
}

// returns true if the operation succeeded, false otherwise
$zkBox.StopMaintenance = function()
{
    var ret = false;

    $zkBox.utils.runFunctionOnly("fnStart", $zkBox.callbacks.fnStart)("StopMaintenance");

    $zkBox.maintenance.core.StopMaintenance(
        function(msg)
        {
            $zkBox.utils.runFunctionOnly("fnProgress", $zkBox.callbacks.fnProgress)(msg);
        },
        function()
        {
            $zkBox.utils.runFunctionOnly("fnSuccess", $zkBox.callbacks.fnSuccess)();
            ret = true;
        },
        function(error)
        {
            $zkBox.utils.runFunctionOnly("fnError", $zkBox.callbacks.fnError)(error);
        });

    $zkBox.utils.runFunctionOnly("fnStop", $zkBox.callbacks.fnStop)("StopMaintenance");

    return ret;
}
