// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


$zkBox.status =
{
    user: "",
    pass: "",

    // Authentication parameters
    userId: "",
    userVersion: "",
    sessionId: "",

    // The session's key used to sign the requests (input for HMAC-SHA512)
    sessionKey: "",

    cryptoKey: "",

    // The crypto key used to encrypt the data (input for AES256)
    cryptoKeyRaw: [],

    isAuthenticated: false,

    updateAuth: function()
    {
        this.cryptoKeyRaw = base16_decode(this.cryptoKey);
        if ($zkBox.logging) $zkBox.utils.log('Setting cryptoKeyRaw = [' + this.cryptoKeyRaw + ']');

        this.isAuthenticated = true;
    },

    updateUserAuth: function(userAuth)
    {
        if (null == userAuth)
        {
            if ($zkBox.logging) $zkBox.utils.log('Clearing the ' + $zkBox.conf.AuthCookie.Name + ' cookie');
            $zkBox.jquery.cookie(
                $zkBox.conf.AuthCookie.Name,
                null,
                {
                    path: $zkBox.conf.AuthCookie.Path,
                    secure: $zkBox.conf.AuthCookie.Secure
                });
        }
        else
        {
            var val = this.userId + this.userVersion + this.sessionId + userAuth;
            if ($zkBox.logging) $zkBox.utils.log('Setting the ' + $zkBox.conf.AuthCookie.Name + ' cookie to "' + val + '" (Expires="' + $zkBox.conf.AuthCookie.Expires + '", Path="' + $zkBox.conf.AuthCookie.Path + '", Secure="' + $zkBox.conf.AuthCookie.Secure + '")');
            $zkBox.jquery.cookie(
                $zkBox.conf.AuthCookie.Name,
                val,
                {
                    expires: $zkBox.conf.AuthCookie.Expires,
                    path: $zkBox.conf.AuthCookie.Path,
                    secure: $zkBox.conf.AuthCookie.Secure
                });
        }
    },

    clearAuth: function()
    {
        this.user = "";
        this.pass = "";

        //Authentication parameters
        this.userId = "";
        this.userVersion = "";
        this.sessionId = "";
        this.sessionKey = "";
        this.cryptoKey = "";

        this.cryptoKeyRaw = [];

        this.isAuthenticated = false;

        // clear the cache
        $zkBox.utils.cache.clearAllItems();

        if ($zkBox.logging) $zkBox.utils.log('Clearing the ' + $zkBox.conf.AuthCookie.Name + ' cookie');
        $zkBox.jquery.cookie(
            $zkBox.conf.AuthCookie.Name,
            null,
            {
                path: $zkBox.conf.AuthCookie.Path,
                secure: $zkBox.conf.AuthCookie.Secure
            });
    }
}
