﻿// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


// zkBox Transactions
////////  core operations  ////////

$zkBox.transactions.core.Begin = function(fnProgress, fnSuccess, fnError)
{
    if ($zkBox.logging) $zkBox.utils.log('[TRANSACTIONS -> Begin]');

    fnProgress('Starting a new transaction');

    $zkBox.model.Call(false, true, "POST transaction", {},
        function(data)
        {
            fnProgress('The transaction was created');

            fnSuccess(data);
        },
        function(error)
        {
            fnProgress('Failure while creating the transaction');
            fnError(error);
        });
}


$zkBox.transactions.core.Commit = function(transactionId, fnProgress, fnSuccess, fnError)
{
    if ($zkBox.logging) $zkBox.utils.log('[TRANSACTIONS -> Commit (transactionId="{0}")]',
        transactionId);

    fnProgress('Committing the transaction');

    $zkBox.model.Call(false, true, "PUT transaction/" + transactionId, {},
        function(data)
        {
            fnProgress('The transaction was committed');

            fnSuccess(data);
        },
        function(error)
        {
            fnProgress('Failure while committing the transaction');
            fnError(error);
        });
}


$zkBox.transactions.core.Rollback = function(transactionId, fnProgress, fnSuccess, fnError)
{
    if ($zkBox.logging) $zkBox.utils.log('[TRANSACTIONS -> Rollback (transactionId="{0}")]',
        transactionId);

    fnProgress('Rolling back the transaction');

    $zkBox.model.Call(false, true, "DELETE transaction/" + transactionId, {},
        function(data)
        {
            fnProgress('The transaction was rolled back');

            fnSuccess(data);
        },
        function(error)
        {
            fnProgress('Failure while rolling back the transaction');
            fnError(error);
        });
}