﻿// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


// returns the transactionId if the operation succeeded, null otherwise
$zkBox.transactions.Begin = function(ctx)
{
    var ret = null;

    $zkBox.transactions.core.Begin(
        function(msg)
        {
            $zkBox.utils.runFunctionOnly("fnProgress", $zkBox.callbacks.fnProgress)(msg);
        },
        function(data)
        {
            $zkBox.utils.runFunctionOnly("fnSuccess", $zkBox.callbacks.fnSuccess)(data);
            ret = data.transactionId;
        },
        function(error)
        {
            $zkBox.utils.runFunctionOnly("fnError", $zkBox.callbacks.fnError)(error);
        });


    return ret;
}

// returns true the operation succeeded, null otherwise
$zkBox.transactions.Commit = function(ctx, transactionId)
{
    var ret = null;

    $zkBox.transactions.core.Commit(transactionId,
        function(msg)
        {
            $zkBox.utils.runFunctionOnly("fnProgress", $zkBox.callbacks.fnProgress)(msg);
        },
        function(data)
        {
            $zkBox.utils.runFunctionOnly("fnSuccess", $zkBox.callbacks.fnSuccess)(data);
            ret = true;
        },
        function(error)
        {
            $zkBox.utils.runFunctionOnly("fnError", $zkBox.callbacks.fnError)(error);
        });

    if (true == ret)
    {
        // reflect the changes into the cache; ignore the result from the cache update
        $zkBox.cache.transactions.core.CommitTransaction(transactionId);
    }

    return ret;
}


// returns true the operation succeeded, null otherwise
$zkBox.transactions.Rollback = function(ctx, transactionId)
{
    var ret = null;

    $zkBox.transactions.core.Rollback(transactionId,
        function(msg)
        {
            $zkBox.utils.runFunctionOnly("fnProgress", $zkBox.callbacks.fnProgress)(msg);
        },
        function(data)
        {
            $zkBox.utils.runFunctionOnly("fnSuccess", $zkBox.callbacks.fnSuccess)(data);
            ret = true;
        },
        function(error)
        {
            $zkBox.utils.runFunctionOnly("fnError", $zkBox.callbacks.fnError)(error);
        });

    if (true == ret)
    {
        // reflect the changes into the cache; ignore the result
        $zkBox.cache.transactions.core.RollbackTransaction(transactionId);
    }

    return ret;
}
