// zkBox JavaScript client
// http://www.zkbox.com/developers/client/javascript
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
//
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


$zkBox.utils.cache =
{
    cache: null,

    initialize: function()
    {
        this.cache = new zkBoxCache();
    },

    setItem: function(key, value)
    {
        if ($zkBox.logging) $zkBox.utils.log('Cache.setItem("{0}")="{1}"', key, $zkBox.utils.dump(value));
        this.cache.setItem(key, value);
    },

    getItem: function(key)
    {
        var ret = $zkBox.utils.clone(this.cache.getItem(key)); // clone every returned objects from the cache; TODO_LATER: change/optimize this?
        if ($zkBox.logging) $zkBox.utils.log('Cache.getItem("{0}") will return "{1}"', key, $zkBox.utils.dump(ret));
        return ret;
    },

    removeItem: function(key)
    {
        if ($zkBox.logging) $zkBox.utils.log('Cache.removeItem("{0}")', key);
        this.cache.removeItem(key);
    },

    clearAllItems: function()
    {
        if ($zkBox.logging) $zkBox.utils.log('Cache.clearAllItems()');
        this.cache.clear();
    },

    containsItem: function(key)
    {
        var value = this.cache.getItem(key);
        var ret = false;
        if (null != value)
        {
            ret = true;
        }
        if ($zkBox.logging) $zkBox.utils.log('Cache.containsItem("{0}") will return "{1}"', key, ret);
        return ret;
    }
}
