﻿// zkBox ASP.NET web proxy
// http://www.zkbox.com/developers/client/javascript/aspnet
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Bitground.zkBox.Client.JS.WebProxy
{
    public class Application : IDisposable
    {
        private Application()
        {
        }

        private CS.Handler api;
        public Application(Handler.Init init)
        {
            CS.Handler.Init apiInit = new Bitground.zkBox.Client.CS.Handler.Init()
            {
                apiUrl = init.apiUrl,
                apiVersion = init.apiVersion,
                applicationId = init.applicationId,
                applicationKey = init.applicationKey,
                hasCache = false
            };

            api = new Bitground.zkBox.Client.CS.Handler(apiInit);
        }

        private void Terminate()
        {
            api.Dispose();
        }

        void IDisposable.Dispose()
        {
            Terminate();
        }

        public void Dispose()
        {
            Terminate();
        }

        public class GetApplicationInfo : WSRet<CS.Applications.GetApplicationInfo.Data, GetApplicationInfo.Data>
        {
            public GetApplicationInfo(CS.Applications.GetApplicationInfo appInfo)
                : base(appInfo)
            {
                if (null != appInfo)
                {
                    if (null != appInfo.data)
                    {
                        this.data = new Data();
                        this.data.usersCount = appInfo.data.usersCount;
                        this.data.objectsCount = appInfo.data.objectsCount;
                    }
                }
            }

            public class Data
            {
                public long usersCount;
                public long objectsCount;
            }
        };

        public GetApplicationInfo GetInfo()
        {
            return new GetApplicationInfo(api.Application.GetInfo());
        }
    }
}
