﻿// zkBox JS + ASP.NET client - web sample
// http://www.zkbox.com/developers/client/javascript/aspnet
// 
// Copyright 2010, Sorin Ostafiev
// http://www.ostafiev.com/
// 
// Released under GPL version 3 license
// http://www.gnu.org/licenses/gpl-3.0.txt


using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Configuration;
using Bitground.Common.Helpers;

namespace Bitground.zkBox.Client.Samples.vs2008.Web
{
    public class Global : System.Web.HttpApplication
    {
        protected void Application_Start(object sender, EventArgs e)
        {
            Log.Initialize(new Log.LoggerInit()
            {
                appName = "ZKBOX-SAMPLE-WEBPROXY",
                appInstance = "001",
                loggersMask = Log.Logger.FileAll,
                file = new Log.LoggerInit.File()
                {
                    logFolder = ConfigurationManager.AppSettings["Log.FileFolder"]
                }
            });

            JS.WebProxy.Handler.Initialize(
                new JS.WebProxy.Handler.Init
                {
                    apiUrl = ConfigurationManager.AppSettings["zkBox.apiUrl"],
                    apiVersion = ConfigurationManager.AppSettings["zkBox.apiVersion"],
                    applicationId = ConfigurationManager.AppSettings["zkBox.applicationId"],
                    applicationKey = ConfigurationManager.AppSettings["zkBox.applicationKey"]
                });
        }

        protected void Application_End(object sender, EventArgs e)
        {
            JS.WebProxy.Handler.Dispose();
        }

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }
    }
}
